do

--create an instance of the IADS
redIADS = SkynetIADS:create('RUSA')

---debug settings remove from here on if you do not wan't any output on what the IADS is doing by default
local iadsDebug = redIADS:getDebugSettings()
iadsDebug.IADSStatus = true
-- iadsDebug.radarWentDark = true
iadsDebug.contacts = true
-- iadsDebug.radarWentLive = true
-- iadsDebug.noWorkingCommmandCenter = true
-- iadsDebug.samNoConnection = true
iadsDebug.jammerProbability = true
-- iadsDebug.addedEWRadar = true
-- iadsDebug.harmDefence = true
-- iadsDebug.warnings = true
iadsDebug.samSiteStatusEnvOutput = true
iadsDebug.earlyWarningRadarStatusEnvOutput = true
iadsDebug.commandCenterStatusEnvOutput = true
---end remove debug ---

--add all units with unit name beginning with 'EW' to the IADS:
redIADS:addEarlyWarningRadarsByPrefix('EW')

--add all groups begining with group name 'SAM' to the IADS:
redIADS:addSAMSitesByPrefix('SAM')

--activate the IADS
redIADS:activate()

--activate the radio menu to toggle IADS Status output
redIADS:addRadioMenu()


-- Command Center
local CommandCenter = StaticObject.getByName('Command Center')
local MainPowerSource1 = Unit.getByName('Command Center Power Source')
local MainPowerSource2 = Unit.getByName('Command Center Power Source BkUp')
local connectionNodeEWa = Unit.getByName('Command Center Node')
local connectionNodeEWc = Unit.getByName('Sochi_Adler AAA Dog Ear')
local connectionNode2 = Unit.getByName('OSA EW-1-SR')


if CommandCenter then
redIADS:addCommandCenter(CommandCenter):addPowerSource(MainPowerSource1):addPowerSource(MainPowerSource2):addConnectionNode(connectionNodeEWa):addConnectionNode(connectionNodeEWc):addConnectionNode(connectionNode2)
end

-- EW RADAR
local connectionNodeEW = Unit.getByName("Command Center Node")
local powerSource = StaticObject.getByName("Electric power box EW 1")
redIADS:getEarlyWarningRadarByUnitName('EW 1'):addConnectionNode(connectionNodeEW):addPowerSource(powerSource)

local connectionNodeEW = Unit.getByName("Command Center Node")
redIADS:getEarlyWarningRadarByUnitName('EW 2'):addConnectionNode(connectionNodeEW)

-- SAM sites
local connectionNode = Unit.getByName("Command Center Node")
local powerSource = StaticObject.getByName("Electric power box SAM 10")
redIADS:getSAMSiteByGroupName('SAM S-350_Coastal_Tuapse'):addPowerSource(powerSource):addConnectionNode(connectionNode):setActAsEW(true)

local de = Unit.getByName('Sochi_Adler AAA Dog Ear')
redIADS:getSAMSiteByGroupName('SAM AAA system Sochi-Adler'):setEngagementZone(SkynetIADSAbstractRadarElement.GO_LIVE_WHEN_IN_SEARCH_RANGE):addConnectionNode(de):setHARMDetectionChance(70)

local connectionNode = Unit.getByName("Command Center Node")
redIADS:getSAMSiteByGroupName('SAM Sochi-Adler Buk SA-11 AD'):addConnectionNode(connectionNode):setCanEngageHARM(true):setEngagementZone(SkynetIADSAbstractRadarElement.GO_LIVE_WHEN_IN_SEARCH_RANGE):setHARMDetectionChance(70)

local connectionNode = Unit.getByName("Command Center Node")
local powerSource = StaticObject.getByName("SA-3 Mobile-PS Command Center AD")
redIADS:getSAMSiteByGroupName('SAM SA-3 Command Center AD'):addConnectionNode(connectionNode)

local connectionNode = Unit.getByName("OSA EW-1-SR")
redIADS:getSAMSiteByGroupName('SAM OSA EW-1'):addConnectionNode(connectionNode)


--add the jammer
local jammer = SkynetIADSJammer:create(Unit.getByName('jammer-emitter'), redIADS)
jammer:masterArmOn()
jammer:addRadioMenu()
jammer:setMaximumEffectiveDistance(160)




--setup blue IADS:
blueIADS = SkynetIADS:create('PUSA')

local iadsDebug = blueIADS:getDebugSettings()
iadsDebug.IADSStatus = true
-- iadsDebug.radarWentDark = true
iadsDebug.contacts = true
-- iadsDebug.radarWentLive = true
-- iadsDebug.noWorkingCommmandCenter = true
-- iadsDebug.samNoConnection = true
iadsDebug.jammerProbability = true
-- iadsDebug.addedEWRadar = true
-- iadsDebug.harmDefence = true
-- iadsDebug.warnings = true
iadsDebug.samSiteStatusEnvOutput = true
iadsDebug.earlyWarningRadarStatusEnvOutput = true
iadsDebug.commandCenterStatusEnvOutput = true

blueIADS:addSAMSitesByPrefix('BLUESA')
blueIADS:addEarlyWarningRadarsByPrefix('BLUEEW')

blueIADS:activate()
blueIADS:addRadioMenu()



-- Command Center
local CommandCenter = StaticObject.getByName('Command Center Senaki-Kolkhi')
local MainPowerSource = StaticObject.getByName('Command Center PS Senaki-Kolkhi')
local connectionNodeEW = StaticObject.getByName('Command NODE Senaki-Kolkhi')
local connectionNode1 = Unit.getByName("HAWK Sukhumi-Babushara C2")
local connectionNode2 = Unit.getByName("NASAMS 2 AIM-9X CP")
local connectionNode3 = Unit.getByName("NASAMS 1 AIM-9X Gudauta CP")
local connectionNode4 = Unit.getByName("Senaki-Kolkhi LvS-103-ECS")

if CommandCenter then
blueIADS:addCommandCenter(CommandCenter):addPowerSource(MainPowerSource):addConnectionNode(connectionNodeEW):addConnectionNode(connectionNode1):addConnectionNode(connectionNode2):addConnectionNode(connectionNode3):addConnectionNode(connectionNode4)
end

-- EW RADAR
local connectionNode = StaticObject.getByName("Command NODE Senaki-Kolkhi")
local powerSource = StaticObject.getByName("Patriot EPP-III-1 EW 1")
blueIADS:getEarlyWarningRadarByUnitName('BLUEEW 1'):addConnectionNode(connectionNodeEW):addPowerSource(powerSource)

local connectionNode = StaticObject.getByName("Command NODE Senaki-Kolkhi")
local powerSource = StaticObject.getByName("Patriot EPP-III-1 EW 2")
blueIADS:getEarlyWarningRadarByUnitName('BLUEEW 2'):addConnectionNode(connectionNodeEW):addPowerSource(powerSource)

local connectionNodeEW = StaticObject.getByName('Command NODE Senaki-Kolkhi')
blueIADS:getEarlyWarningRadarByUnitName('BLUEEW E-2D'):addConnectionNode(connectionNodeEW)

-- SAM sites
local connectionNode = Unit.getByName("HAWK Sukhumi-Babushara C2")
local powerSource = StaticObject.getByName("Electric power box HAWK")
blueIADS:getSAMSiteByGroupName('BLUESA HAWK Sukhumi-Babushara'):addPowerSource(powerSource):addConnectionNode(connectionNode):setActAsEW(true)

local connectionNode = Unit.getByName("NASAMS 1 AIM-9X Gudauta CP")
local powerSource = StaticObject.getByName("Patriot EPP-III NASAMS Gudauta")
blueIADS:getSAMSiteByGroupName('BLUESA NASAMS 1 AIM-9X Gudauta'):addPowerSource(powerSource):addConnectionNode(connectionNode)

local connectionNode = StaticObject.getByName("Command NODE Senaki-Kolkhi")
local powerSource = StaticObject.getByName("Command Center PS Senaki-Kolkhi")
blueIADS:getSAMSiteByGroupName('BLUESA NAS Senaki-Kolkhi'):addPowerSource(powerSource):addConnectionNode(connectionNode):setActAsEW(true)

local connectionNode = Unit.getByName("Senaki-Kolkhi LvS-103-ECS")
local powerSource = Unit.getByName("Senaki-Kolkhi LvS-103-EPP")
blueIADS:getSAMSiteByGroupName('BLUESA Senaki-Kolkhi LvS-103'):addPowerSource(powerSource):addConnectionNode(connectionNode):setActAsEW(true)

local connectionNode = StaticObject.getByName("Command NODE Senaki-Kolkhi")
local powerSource = StaticObject.getByName("PS BLUESA RAPIER")
blueIADS:getSAMSiteByGroupName('BLUESA RAPIER'):addPowerSource(powerSource):addConnectionNode(connectionNode)

local connectionNode = Unit.getByName("NASAMS 2 AIM-9X CP")
local powerSource = Unit.getByName("NASAMS 2 AIM-9X PS")
blueIADS:getSAMSiteByGroupName('BLUESA NASAMS 2 AIM-9X Gudauta'):addPowerSource(powerSource):addConnectionNode(connectionNode)


-- START MOOSE CODE:
-- Define a SET_GROUP object that builds a collection of groups that define the EWR network.
DetectionSetGroup = SET_GROUP:New()

-- add the MOOSE SET_GROUP to the IADS, from now on Skynet will update active radars that the MOOSE SET_GROUP can use for EW detection.
redIADS:addMooseSetGroup(DetectionSetGroup)

-- Setup the detection and group targets to a 40km range!
Detection = DETECTION_AREAS:New( DetectionSetGroup, 50000 )


-- Setup the A2A dispatcher, and initialize it.
A2ADispatcher = AI_A2A_DISPATCHER:New( Detection )

-- Set 100km as the radius to engage any target by airborne friendlies.
A2ADispatcher:SetEngageRadius(200000) -- 100000 is the default value.

-- Set 200km as the radius to ground control intercept.
A2ADispatcher:SetGciRadius(250000) -- 200000 is the default value.

A2ADispatcher:SetDefaultCapTimeInterval( 180, 360 ) -- Between 300 and 1200 seconds.
A2ADispatcher:SetDefaultOverhead( 0.5 )
A2ADispatcher:SetDefaultGrouping( 2 )
A2ADispatcher:SetDefaultTakeoffInAir()
A2ADispatcher:SetDefaultLandingNearAirbase()
A2ADispatcher:SetDefaultTakeoffInAirAltitude( 600 )
A2ADispatcher:SetDefaultFuelThreshold( 0.20 )
A2ADispatcher:SetDefaultDamageThreshold( 0.50 ) -- Go RTB when the airplane 70% damaged.
A2ADispatcher:SetDisengageRadius( 300000 ) -- 300000 is the default value.


CCCPBorderZone = ZONE_POLYGON:New( "CCCP BORDER", GROUP:FindByName( "CCCP BORDER" ) )
A2ADispatcher:SetBorderZone( CCCPBorderZone )
A2ADispatcher:SetSquadron( "Maykop", AIRBASE.Caucasus.Maykop_Khanskaya, { "SQ Mig29S" }, 20 )
A2ADispatcher:SetSquadron( "Gelendzhik", AIRBASE.Caucasus.Gelendzhik, { "SQ Mig31", "SQ Su-33" }, 20 )
A2ADispatcher:SetSquadron( "Mineralnye", AIRBASE.Caucasus.Mineralnye_Vody, { "SQ Mig29A" }, 20 )
A2ADispatcher:SetSquadron( "Sochi", AIRBASE.Caucasus.Sochi_Adler, { "SQ Su27" }, 10 )
A2ADispatcher:SetSquadron( "Nalchik", AIRBASE.Caucasus.Nalchik, { "SQ MiG-21bis" }, 12 )
A2ADispatcher:SetSquadronGci( "Maykop", 600, 1200 )
A2ADispatcher:SetSquadronGci( "Gelendzhik", 600, 1400 )

CAPZoneWest = ZONE_POLYGON:New("CAPZoneOuest", GROUP:FindByName( "CAPZoneOuest" ))
A2ADispatcher:SetSquadronCap( "Sochi", CAPZoneWest, 4000, 10000, 600, 800, 800, 1200, "RADIO" )
A2ADispatcher:SetSquadronCapInterval( "Sochi", 2, 180, 360 )

CAPZoneEast = ZONE_POLYGON:New("CAPZoneEoust", GROUP:FindByName( "CAPZoneEoust" ))
A2ADispatcher:SetSquadronCap( "Mineralnye", CAPZoneEast, 4000, 10000, 600, 800, 800, 1200, "RADIO" )
A2ADispatcher:SetSquadronCapInterval( "Mineralnye", 1, 180, 360 )
A2ADispatcher:SetSquadronCap( "Nalchik", CAPZoneEast, 4000, 10000, 600, 800, 800, 1200, "RADIO" )
A2ADispatcher:SetSquadronCapInterval( "Nalchik", 1, 180, 360 )


A2ADispatcher:SetSquadronTakeoffInAir("Maykop")
A2ADispatcher:SetSquadronTakeoffInAir("Gelendzhik")
A2ADispatcher:SetSquadronTakeoffInAir("Mineralnye")
A2ADispatcher:SetSquadronTakeoffInAir("Sochi")
A2ADispatcher:SetSquadronTakeoffInAir("Nalchik")
A2ADispatcher:SetSquadronLandingNearAirbase("Maykop")
A2ADispatcher:SetSquadronLandingNearAirbase("Gelendzhik")
A2ADispatcher:SetSquadronLandingNearAirbase("Mineralnye")
A2ADispatcher:SetSquadronLandingNearAirbase("Sochi")
A2ADispatcher:SetSquadronLandingNearAirbase("Nalchik")


A2ADispatcher:SetTacticalDisplay(false)
A2ADispatcher:Start()
--END MOOSE CODE



end

-- AM site can have a user defined function on goLive and goDark events.
-- When going live:

-- samSite:onGoLive(function(unit)
--   ... do something here ..
-- end)

-- or when going dark:

-- samSite:onGoDark(function(unit)
--   ... do something here ..
-- end)

-- The function will have the samSite object avaiable for user to interact with the SAM.

-- this example will cause all SA-15 batteries connected to IADS to move 500m in a random direction and speed when going dark
-- redTor = redIADS:getSAMSitesByNatoName('SA-15')

--redTor:onGoDark(function(unit)
	mist.groupRandomDistSelf(unit:getDCSName() , 500)
--end)

-- this example will cause all SA-17 batteries connected to IADS to move 500m in a random direction and speed when going live
-- redTor = redIADS:getSAMSitesByNatoName('SA-17')

-- redTor:onGoLive(function(unit)
 	mist.groupRandomDistSelf(unit:getDCSName() , 500)
-- end) 